var util = require('../../utils/util.js');
var api = require('../../config/api.js');
var app = getApp()
Page({
  data: {
    userInfo: {},
    curUser: {},
    idNoM: '',
    idNo: '',
    currentIdNo: '',
    userName: '',
    array: ['居民身份证'],
    items: [
      { name: '1', value: '反光识别', checked: 'true' },
      { name: '2', value: '读数识别' },
    ],
    isAgree: false
  },
  radioChange: function (e) {
    console.log('radio发生change事件，携带value值为：', e.detail.value)
  },
  checkBoxAgree: function(e){
    this.setData({
      isAgree: !this.data.isAgree
    });
  },
  onLoad: function (options) {
    // 页面初始化 options为页面跳转所带来的参数
    let that = this;
  },
  onReady: function () {

  },
  onShow: function () {
    let that = this;
    let userInfo = wx.getStorageSync('userInfo');
    let token = wx.getStorageSync('token');

    // 页面显示
    if (userInfo && token) {
      app.globalData.userInfo = userInfo;
      app.globalData.token = token;

      this.setData({
        userInfo: app.globalData.userInfo,
      });
      util.request(api.getCurUser, {
        userInfo: app.globalData.userInfo
      }, 'POST').then(function (res) {
        if (res.errno === 0) {
          that.setData({
            curUser: res.data
          });
          if (res.data.idNo) {
            that.setData({
              idNoM: that.formatidcard(res.data.idNo),
              idNo: res.data.idNo,
              currentIdNo: res.data.idNo,
              userName: res.data.username
            });
          }
        }
      });
    } else {
      wx.navigateTo({
        url: '/pages/ucenter/userLogin/userLogin'
      })
    }

  },
  onHide: function () {
    // 页面隐藏

  },
  onUnload: function () {
    // 页面关闭
  },
  readUserService: function(){
    // wx.navigateTo({
    //   url: '../userService/userService'
    // });
  },
  readUserPrivacy: function () {
    // wx.navigateTo({
    //   url: '../userPrivacy/userPrivacy'
    // });
  },
  saveIdCard: function (e) {
    let that = this;
    if (that.data.isAgree == false) {
      wx.showToast({
        title: '请先阅读并勾选内容',
        icon: 'none'
      });
      return false;
    }
    if (!e.detail.value.idNo) {
      wx.showToast({
        title: '身份证号不能为空',
        icon: 'none'
      });
      return false;
    }

    if (!e.detail.value.username) {
      wx.showToast({
        title: '姓名不能为空',
        icon: 'none'
      });
      return false;
    }
    if (that.data.idNoM != that.formatidcard(e.detail.value.idNo)) {
      that.setData({
        idNo: e.detail.value.idNo
      });
    } else {
      that.setData({
        idNo: that.data.currentIdNo
      });
    }
    that.setData({
      userName: e.detail.value.username
    });
    console.log(that.data.idNo);

    if (!that.checkIdcard(that.data.idNo)) {
      wx.showToast({
        title: '请输入正确的身份证号',
        icon: 'none'
      });
      return false;
    }

    wx.navigateTo({
      url: '../checkVideo/checkVideo'
    });
    /**util.request(api.idCardRealName, {
      idNo: that.data.idNo,
      userName: that.data.userName
    }, 'POST').then(function (res) {
      if (res.errno === 0) {
        //成功提示
        // wx.showToast({
        //   title: res.errmsg
        // });
        that.setData({
          idNoM: that.formatidcard(e.detail.value.idNo)
        });
        wx.navigateTo({
          url: '../checkVideo/checkVideo'
        });
      } else {
        wx.showToast({
          title: res.errmsg,
          icon: 'none'
        });
      }
    });**/
  },
  clearData: function () {
    let that = this;
    that.setData({
      idNoM: ''
    });
  },
  formatidcard(idcard) {
    var reg = /^(.).+(.)$/g;
    if (idcard.length == 15) {
      // return idcard.replace(/(\d{6})\d{6}(\d{3})/, "$1******$2");
      return idcard.replace(reg, "$1*************$2");
    } else {
      return idcard.replace(reg, "$1****************$2");
    }
  },
  // 校验身份证号
  //校验码校验
  checkCode: function (val) {
    var p = /^[1-9]\d{5}(18|19|20)\d{2}((0[1-9])|(1[0-2]))(([0-2][1-9])|10|20|30|31)\d{3}[0-9Xx]$/;
    var factor = [7, 9, 10, 5, 8, 4, 2, 1, 6, 3, 7, 9, 10, 5, 8, 4, 2];
    var parity = [1, 0, 'X', 9, 8, 7, 6, 5, 4, 3, 2];
    var code = val.substring(17);
    if (p.test(val)) {
      var sum = 0;
      for (var i = 0; i < 17; i++) {
        sum += val[i] * factor[i];
      }
      if (parity[sum % 11] == code.toUpperCase()) {
        return true;
      }
    }
    return false;
  },
  //省份校验
  checkProv: function (val) {
    var pattern = /^[1-9][0-9]/;
    var provs = { 11: "北京", 12: "天津", 13: "河北", 14: "山西", 15: "内蒙古", 21: "辽宁", 22: "吉林", 23: "黑龙江 ", 31: "上海", 32: "江苏", 33: "浙江", 34: "安徽", 35: "福建", 36: "江西", 37: "山东", 41: "河南", 42: "湖北 ", 43: "湖南", 44: "广东", 45: "广西", 46: "海南", 50: "重庆", 51: "四川", 52: "贵州", 53: "云南", 54: "西藏 ", 61: "陕西", 62: "甘肃", 63: "青海", 64: "宁夏", 65: "新疆", 71: "台湾", 81: "香港", 82: "澳门" };
    if (pattern.test(val)) {
      if (provs[val]) {
        return true;
      }
    }
    return false;
  },
  //出生日期码校验
  checkDate: function (val) {
    var pattern = /^(18|19|20)\d{2}((0[1-9])|(1[0-2]))(([0-2][1-9])|10|20|30|31)$/;
    if (pattern.test(val)) {
      var year = val.substring(0, 4);
      var month = val.substring(4, 6);
      var date = val.substring(6, 8);
      var date2 = new Date(year + "-" + month + "-" + date);
      if (date2 && date2.getMonth() == (parseInt(month) - 1)) {
        return true;
      }
    }
    return false;
  },
  checkIdcard: function (val) {
    if (this.checkCode(val)) {
      var date = val.substring(6, 14);
      if (this.checkDate(date)) {
        if (this.checkProv(val.substring(0, 2))) {
          return true;
        }
      }
    }
    // this.isError("请输入正确身份证号");
    return false;
  },
  // 通过身份证号获取出生日期和性别
  getBirthAndSex: function (idCard) {
    var that = this;
    var info = {};
    var birth = (idCard.length === 18) ? idCard.slice(6, 14) : idCard.slice(6, 12);
    var order = (idCard.length === 18) ? idCard.slice(-2, -1) : idCard.slice(-1);
    info.birthDay = (idCard.length === 18) ? ([birth.slice(0, 4), birth.slice(4, 6), birth.slice(-2)]).join('-') : (['19' + birth.slice(0, 2), birth.slice(2, 4), birth.slice(-2)]).join('-');
    info.sex = (order % 2 === 0 ? 2 : 0);
    return info;
  }

})